package sun.awt.windows;

import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.List;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.peer.ListPeer;

class WListPeer extends WComponentPeer implements ListPeer {
   public Dimension minimumSize() {
      return this.minimumSize(4);
   }

   public boolean isFocusTraversable() {
      return true;
   }

   public int[] getSelectedIndexes() {
      List var1 = (List)super.target;
      int var2 = var1.countItems();
      int[] var3 = new int[var2];
      int var4 = 0;

      for(int var5 = 0; var5 < var2; ++var5) {
         if (this.isSelected(var5)) {
            var3[var4++] = var5;
         }
      }

      int[] var6 = new int[var4];
      System.arraycopy(var3, 0, var6, 0, var4);
      return var6;
   }

   public void add(String var1, int var2) {
      this.addItem(var1, var2);
   }

   public void removeAll() {
      this.clear();
   }

   public void setMultipleMode(boolean var1) {
      this.setMultipleSelections(var1);
   }

   public Dimension getPreferredSize(int var1) {
      return this.preferredSize(var1);
   }

   public Dimension getMinimumSize(int var1) {
      return this.minimumSize(var1);
   }

   public native void addItem(String var1, int var2);

   public native void delItems(int var1, int var2);

   public void clear() {
      List var1 = (List)super.target;
      this.delItems(0, var1.countItems());
   }

   public native void select(int var1);

   public native void deselect(int var1);

   public native void makeVisible(int var1);

   public native void setMultipleSelections(boolean var1);

   public Dimension preferredSize(int var1) {
      return this.minimumSize(var1);
   }

   public Dimension minimumSize(int var1) {
      FontMetrics var2 = ((WComponentPeer)this).getFontMetrics(((List)super.target).getFont());
      return new Dimension(20 + var2.stringWidth("0123456789abcde"), var2.getHeight() * var1 + 4);
   }

   WListPeer(List var1) {
      super(var1);
   }

   native void create(WComponentPeer var1);

   void initialize() {
      List var1 = (List)super.target;
      int var2 = var1.countItems();

      for(int var3 = 0; var3 < var2; ++var3) {
         this.addItem(var1.getItem(var3), -1);
      }

      this.setMultipleSelections(var1.allowsMultipleSelections());
      int var4 = var1.getVisibleIndex();
      if (var4 >= 0) {
         this.makeVisible(var4);
      }

      int[] var5 = var1.getSelectedIndexes();

      for(int var6 = 0; var6 < var5.length; ++var6) {
         this.select(var5[var6]);
      }

      super.initialize();
   }

   native boolean isSelected(int var1);

   void handleAction(int var1) {
      List var2 = (List)super.target;
      var2.select(var1);
      WToolkit.postEvent(new ActionEvent(super.target, 1001, var2.getItem(var1)));
   }

   void handleListChanged(int var1) {
      List var2 = (List)super.target;
      WToolkit.postEvent(new ItemEvent(var2, 701, new Integer(var1), this.isSelected(var1) ? 1 : 2));
   }
}
