package sun.awt.windows;

import java.awt.Adjustable;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Point;
import java.awt.ScrollPane;
import java.awt.peer.ScrollPanePeer;

class WScrollPanePeer extends WPanelPeer implements ScrollPanePeer {
   int scrollbarWidth = this._getVScrollbarWidth();
   int scrollbarHeight = this._getHScrollbarHeight();
   boolean ignore = false;

   native void create(WComponentPeer var1);

   native int getOffset(int var1);

   WScrollPanePeer(Component var1) {
      super(var1);
   }

   void initialize() {
      super.initialize();
      this.setInsets();
   }

   public void setUnitIncrement(Adjustable var1, int var2) {
   }

   public Insets insets() {
      return ((WPanelPeer)this).getInsets();
   }

   private native void setInsets();

   public synchronized native void setScrollPosition(int var1, int var2);

   public int getHScrollbarHeight() {
      return this.scrollbarHeight;
   }

   private native int _getHScrollbarHeight();

   public int getVScrollbarWidth() {
      return this.scrollbarWidth;
   }

   private native int _getVScrollbarWidth();

   public Point getScrollOffset() {
      int var1 = this.getOffset(0);
      int var2 = this.getOffset(1);
      return new Point(var1, var2);
   }

   public void childResized(int var1, int var2) {
      ScrollPane var3 = (ScrollPane)super.target;
      Dimension var4 = ((Component)var3).getSize();
      this.setSpans(var4.width, var4.height, var1, var2);
      this.setInsets();
   }

   synchronized native void setSpans(int var1, int var2, int var3, int var4);

   public void setValue(Adjustable var1, int var2) {
      if (!this.ignore) {
         Component var3 = this.getScrollChild();
         Point var4 = var3.getLocation();
         switch (var1.getOrientation()) {
            case 0:
               this.setScrollPosition(var2, -var4.y);
               return;
            case 1:
               this.setScrollPosition(-var4.x, var2);
               return;
         }
      }

   }

   private native Component getScrollChild();

   void scrolledVertical(int var1) {
      ScrollPane var2 = (ScrollPane)super.target;
      Adjustable var3 = var2.getVAdjustable();
      if (var3 != null) {
         Adjustor var4 = new Adjustor(this, var3, var1, this);
         WToolkit.postEvent(var4);
      }

   }

   void scrolledHorizontal(int var1) {
      ScrollPane var2 = (ScrollPane)super.target;
      Adjustable var3 = var2.getHAdjustable();
      if (var3 != null) {
         Adjustor var4 = new Adjustor(this, var3, var1, this);
         WToolkit.postEvent(var4);
      }

   }
}
