package sun.awt.windows;

import java.awt.AWTEvent;
import java.awt.Button;
import java.awt.Canvas;
import java.awt.Checkbox;
import java.awt.CheckboxMenuItem;
import java.awt.Choice;
import java.awt.Dialog;
import java.awt.FileDialog;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Frame;
import java.awt.Image;
import java.awt.Label;
import java.awt.List;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.Panel;
import java.awt.PopupMenu;
import java.awt.PrintJob;
import java.awt.ScrollPane;
import java.awt.Scrollbar;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.Toolkit;
import java.awt.Window;
import java.awt.datatransfer.Clipboard;
import java.awt.image.ColorModel;
import java.awt.image.ImageObserver;
import java.awt.image.ImageProducer;
import java.awt.peer.ButtonPeer;
import java.awt.peer.CanvasPeer;
import java.awt.peer.CheckboxMenuItemPeer;
import java.awt.peer.CheckboxPeer;
import java.awt.peer.ChoicePeer;
import java.awt.peer.DialogPeer;
import java.awt.peer.FileDialogPeer;
import java.awt.peer.FontPeer;
import java.awt.peer.FramePeer;
import java.awt.peer.LabelPeer;
import java.awt.peer.ListPeer;
import java.awt.peer.MenuBarPeer;
import java.awt.peer.MenuItemPeer;
import java.awt.peer.MenuPeer;
import java.awt.peer.PanelPeer;
import java.awt.peer.PopupMenuPeer;
import java.awt.peer.ScrollPanePeer;
import java.awt.peer.ScrollbarPeer;
import java.awt.peer.TextAreaPeer;
import java.awt.peer.TextFieldPeer;
import java.awt.peer.WindowPeer;
import java.io.IOException;
import java.util.Properties;
import sun.awt.SunToolkit;
import sun.awt.image.ImageRepresentation;

public class WToolkit extends SunToolkit implements Runnable {
   static final boolean enableDebug = true;
   boolean dbgTrace = false;
   private static final String propTrace = "WINAWT.Trace";
   boolean dbgVerify = false;
   private static final String propVerify = "WINAWT.VerifyComponents";
   boolean dbgBreak = false;
   private static final String propBreak = "WINAWT.BreakOnFailure";
   boolean dbgHeapCheck = false;
   private static final String propHeapCheck = "WINAWT.HeapCheck";
   WClipboard clipboard;
   static ColorModel screenmodel;

   public WToolkit() {
      this.InitializeDebuggingOptions();
      synchronized(this){}

      try {
         (new Thread(this, "AWT-Windows")).start();

         try {
            this.wait();
         } catch (InterruptedException var4) {
         }
      } catch (Throwable var5) {
         throw var5;
      }

   }

   private void InitializeDebuggingOptions() {
      String var1 = Toolkit.getProperty("WINAWT.Trace", "false");
      this.dbgTrace = Boolean.valueOf(var1);
      var1 = Toolkit.getProperty("WINAWT.VerifyComponents", "false");
      this.dbgVerify = Boolean.valueOf(var1);
      var1 = Toolkit.getProperty("WINAWT.BreakOnFailure", "false");
      this.dbgBreak = Boolean.valueOf(var1);
      var1 = Toolkit.getProperty("WINAWT.HeapCheck", "false");
      this.dbgHeapCheck = Boolean.valueOf(var1);
   }

   public native void init(Thread var1);

   public void run() {
      Thread var1 = Thread.currentThread();
      this.init(var1);
      synchronized(this){}

      try {
         this.notifyAll();
      } catch (Throwable var4) {
         throw var4;
      }

      this.eventLoop();
   }

   native void eventLoop();

   static void postEvent(AWTEvent var0) {
      SunToolkit.theEventQueue.postEvent(var0);
   }

   public ButtonPeer createButton(Button var1) {
      WButtonPeer var2 = new WButtonPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public TextFieldPeer createTextField(TextField var1) {
      WTextFieldPeer var2 = new WTextFieldPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public LabelPeer createLabel(Label var1) {
      WLabelPeer var2 = new WLabelPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public ListPeer createList(List var1) {
      WListPeer var2 = new WListPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public CheckboxPeer createCheckbox(Checkbox var1) {
      WCheckboxPeer var2 = new WCheckboxPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public ScrollbarPeer createScrollbar(Scrollbar var1) {
      WScrollbarPeer var2 = new WScrollbarPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public ScrollPanePeer createScrollPane(ScrollPane var1) {
      WScrollPanePeer var2 = new WScrollPanePeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public TextAreaPeer createTextArea(TextArea var1) {
      WTextAreaPeer var2 = new WTextAreaPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public ChoicePeer createChoice(Choice var1) {
      WChoicePeer var2 = new WChoicePeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public FramePeer createFrame(Frame var1) {
      WFramePeer var2 = new WFramePeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public CanvasPeer createCanvas(Canvas var1) {
      WCanvasPeer var2 = new WCanvasPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public PanelPeer createPanel(Panel var1) {
      WPanelPeer var2 = new WPanelPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public WindowPeer createWindow(Window var1) {
      WWindowPeer var2 = new WWindowPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public DialogPeer createDialog(Dialog var1) {
      WDialogPeer var2 = new WDialogPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public FileDialogPeer createFileDialog(FileDialog var1) {
      WFileDialogPeer var2 = new WFileDialogPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public MenuBarPeer createMenuBar(MenuBar var1) {
      WMenuBarPeer var2 = new WMenuBarPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public MenuPeer createMenu(Menu var1) {
      WMenuPeer var2 = new WMenuPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public PopupMenuPeer createPopupMenu(PopupMenu var1) {
      WPopupMenuPeer var2 = new WPopupMenuPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public MenuItemPeer createMenuItem(MenuItem var1) {
      WMenuItemPeer var2 = new WMenuItemPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public CheckboxMenuItemPeer createCheckboxMenuItem(CheckboxMenuItem var1) {
      WCheckboxMenuItemPeer var2 = new WCheckboxMenuItemPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public WEmbeddedFramePeer createEmbeddedFrame(WEmbeddedFrame var1) {
      WEmbeddedFramePeer var2 = new WEmbeddedFramePeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   static boolean prepareScrImage(Image var0, int var1, int var2, ImageObserver var3) {
      if (var1 != 0 && var2 != 0) {
         WImage var4 = (WImage)var0;
         if (((sun.awt.image.Image)var4).hasError()) {
            if (var3 != null) {
               var3.imageUpdate(var0, 192, -1, -1, -1, -1);
            }

            return false;
         } else {
            ImageRepresentation var5 = var4.getImageRep();
            return var5.prepare(var3);
         }
      } else {
         return true;
      }
   }

   static int checkScrImage(Image var0, int var1, int var2, ImageObserver var3) {
      WImage var4 = (WImage)var0;
      int var5;
      if (var1 != 0 && var2 != 0) {
         var5 = var4.getImageRep().check(var3);
      } else {
         var5 = 32;
      }

      return ((sun.awt.image.Image)var4).check(var3) | var5;
   }

   public int checkImage(Image var1, int var2, int var3, ImageObserver var4) {
      return checkScrImage(var1, var2, var3, var4);
   }

   public boolean prepareImage(Image var1, int var2, int var3, ImageObserver var4) {
      return prepareScrImage(var1, var2, var3, var4);
   }

   public Image createImage(ImageProducer var1) {
      return new WImage(var1);
   }

   static native ColorModel makeColorModel();

   static ColorModel getStaticColorModel() {
      if (screenmodel == null) {
         screenmodel = makeColorModel();
      }

      return screenmodel;
   }

   public ColorModel getColorModel() {
      return getStaticColorModel();
   }

   public native int getScreenResolution();

   protected native int getScreenWidth();

   protected native int getScreenHeight();

   public FontMetrics getFontMetrics(Font var1) {
      return WFontMetrics.getFontMetrics(var1);
   }

   public FontPeer getFontPeer(String var1, int var2) {
      return new WFontPeer(var1, var2);
   }

   public native void sync();

   public PrintJob getPrintJob(Frame var1, String var2, Properties var3) {
      SecurityManager var4 = System.getSecurityManager();
      if (var4 != null) {
         var4.checkPrintJobAccess();
      }

      WPrintJob var5 = null;

      try {
         var5 = new WPrintJob("AWT Print");
      } catch (IOException var6) {
      }

      return var5.initJob();
   }

   public native void beep();

   public Clipboard getSystemClipboard() {
      SecurityManager var1 = System.getSecurityManager();
      if (var1 != null) {
         var1.checkSystemClipboardAccess();
      }

      if (this.clipboard == null) {
         this.clipboard = new WClipboard();
      }

      return this.clipboard;
   }

   protected native void loadSystemColors(int[] var1);

   public static final Object targetToPeer(Object var0) {
      return SunToolkit.targetToPeer(var0);
   }

   public static final void targetDisposedPeer(Object var0, Object var1) {
      SunToolkit.targetDisposedPeer(var0, var1);
   }

   static {
      System.loadLibrary("winawt");
   }
}
