package sun.awt.windows;

import java.awt.Component;
import java.awt.Container;
import java.awt.Font;
import java.awt.Insets;
import java.awt.Window;
import java.awt.peer.WindowPeer;
import java.util.Vector;

class WWindowPeer extends WPanelPeer implements WindowPeer {
   static Vector allWindows = new Vector();

   public void dispose() {
      allWindows.removeElement(this);
      super.dispose();
   }

   public native void toFront();

   public native void toBack();

   public void setTitle(String var1) {
      if (var1 == null) {
         var1 = new String("");
      }

      this._setTitle(var1);
   }

   native void _setTitle(String var1);

   public void setResizable(boolean var1) {
      this._setResizable(var1);
      ((Component)super.target).invalidate();
   }

   public native void _setResizable(boolean var1);

   WWindowPeer(Window var1) {
      super(var1);
   }

   void initialize() {
      super.initialize();
      this.updateInsets(super.insets_);
      allWindows.addElement(this);
      Font var1 = ((Window)super.target).getFont();
      if (var1 == null) {
         var1 = new Font("Dialog", 0, 12);
         ((Window)super.target).setFont(var1);
         ((WComponentPeer)this).setFont(var1);
      }

   }

   native void create(WComponentPeer var1);

   native void updateInsets(Insets var1);

   WComponentPeer getFocusPeer() {
      for(Object var1 = ((Window)super.target).getFocusOwner(); var1 != null; var1 = ((Component)var1).getParent()) {
         WComponentPeer var2 = (WComponentPeer)((Component)var1).getPeer();
         if (var2 != null) {
            return var2;
         }
      }

      return null;
   }

   void setDefaultFocus() {
      if (!this.setDefaultFocus((Container)super.target)) {
         Component var1;
         Component var2;
         for(var1 = (Component)super.target; var1 instanceof Container && ((Container)var1).getComponentCount() > 0; var1 = var2) {
            var2 = this.getContainerElement((Container)var1, 0);
            if (!var2.isVisible() || !var2.isEnabled()) {
               break;
            }
         }

         var1.requestFocus();
      }
   }

   private boolean setDefaultFocus(Container var1) {
      int var2 = var1.getComponentCount();

      for(int var3 = 0; var3 < var2; ++var3) {
         Component var4 = this.getContainerElement(var1, var3);
         if (var4.isVisible() && var4.isEnabled() && var4.isFocusTraversable()) {
            var4.requestFocus();
            return true;
         }

         if (var4 instanceof Container && var4.isVisible() && var4.isEnabled() && this.setDefaultFocus((Container)var4)) {
            return true;
         }
      }

      return false;
   }

   private native Component getContainerElement(Container var1, int var2);
}
